///////////////////////////////////////
//                    							 //
//	CommonException Implementation   //
//		                            	 //	
//																	 //
///////////////////////////////////////

#include "CommonException.h"

using namespace Common;

SystemException & SystemException::operator= (const SystemException &other) throw()
{
  exception::operator= (other);  // use base class operator=
  return *this;
}

OutOfRangeException & OutOfRangeException::operator= (const OutOfRangeException &other) throw()
{
  SystemException::operator= (other);  // use base class operator=
  return *this;
}

InvalidPointerException & InvalidPointerException::operator= (const InvalidPointerException &other) throw()
{
  SystemException::operator= (other);  // use base class operator=
  return *this;
}

NegativeValueException & NegativeValueException::operator= (const NegativeValueException &other) throw()
{
  SystemException::operator= (other);  // use base class operator=
  return *this;
}

InvalidSetValueException & InvalidSetValueException::operator= (const InvalidSetValueException &other) throw()
{
  SystemException::operator= (other);  // use base class operator=
  return *this;
}

EmptyStringException & EmptyStringException::operator= (const EmptyStringException &other) throw()
{
  InvalidSetValueException::operator= (other);  // use base class operator=
  return *this;
}

DatabaseException & DatabaseException::operator= (const DatabaseException &other) throw()
{
  SystemException::operator= (other);  // use base class operator=
  return *this;
}

DBObjectNotFoundException & DBObjectNotFoundException::operator= (const DBObjectNotFoundException &other) throw()
{
  DatabaseException::operator= (other);  // use base class operator=
  return *this;
}

InternalException & InternalException::operator= (const InternalException &other) throw()
{
  SystemException::operator= (other);  // use base class operator=
  return *this;
}