//////////////////////////////////////
//                    							//
//		CommonException Header				//
//		                            	//	
//																	//
//////////////////////////////////////

#include <exception>
#include <stdexcept>

#ifndef COMMONEXCEPTION_CLASS
#define COMMONEXCEPTION_CLASS

#ifndef GENERIC_CLASS
#include "c:\scs\common\generic.h"
#endif

namespace Common
{

  class SystemException: public std::exception
    {
      public:
          SystemException()  throw() : exception("System Exception") {}
          SystemException(__exString message) : exception(message) {}
          SystemException(const SystemException &other) throw() : exception(other) {}
          virtual ~SystemException() throw() {}

          SystemException & operator= (const SystemException &other);

    };

  class OutOfRangeException: public SystemException
    {
      public:
       OutOfRangeException() throw() : SystemException("Value Out of Range") {}
        OutOfRangeException(__exString message) throw() : SystemException(message) {}
        virtual ~OutOfRangeException() throw() {}

        OutOfRangeException(const OutOfRangeException &other) throw() : SystemException(other) {}
        OutOfRangeException & operator= (const OutOfRangeException &other) throw();
 
    };

  class InvalidPointerException: public SystemException
   {
      public:
        InvalidPointerException () throw() : SystemException("Invalid Pointer Entered") {}
        InvalidPointerException(__exString message) throw() : SystemException(message) {}
         virtual ~InvalidPointerException() {}

        InvalidPointerException(const InvalidPointerException &other) throw() : SystemException(other) {}
       InvalidPointerException & operator= (const InvalidPointerException &other) throw();
      
   };

  class NegativeValueException: public SystemException
   {
      public:
        NegativeValueException() throw() : SystemException("Negative Value Entered") {}
       NegativeValueException(__exString message) throw() : SystemException(message) {}
       virtual ~NegativeValueException() {} 

       NegativeValueException(const NegativeValueException &other) throw() : SystemException(other) {}
        NegativeValueException & operator= (const NegativeValueException &other) throw();

   };

  class InvalidSetValueException: public SystemException
    {
     public:
        InvalidSetValueException() throw() : SystemException("Invalid Set Function Value") {}
       InvalidSetValueException(__exString message) throw() : SystemException(message) {}
       virtual ~InvalidSetValueException() {} 

       InvalidSetValueException(const InvalidSetValueException &other) throw() : SystemException(other) {}
       InvalidSetValueException & operator= (const InvalidSetValueException &other) throw();
    };

  class EmptyStringException: public InvalidSetValueException
   {
      public:
       EmptyStringException() throw() : InvalidSetValueException("Empty String Entered") {}
       EmptyStringException(__exString message) throw() : InvalidSetValueException(message) {}
        virtual ~EmptyStringException() {} 

       EmptyStringException(const EmptyStringException &other) throw() : InvalidSetValueException(other) {}
       EmptyStringException & operator= (const EmptyStringException &other) throw();

   };

  class DatabaseException: public SystemException
   {
      public:
        DatabaseException() throw() : SystemException("Database exception") {}
        DatabaseException(__exString message) throw() : SystemException(message) {}
        virtual ~DatabaseException() {} 

        DatabaseException(const DatabaseException &other) throw() : SystemException(other) {}
        DatabaseException & operator= (const DatabaseException &other) throw();
   };

  class DBObjectNotFoundException: public DatabaseException
   {
      public:
        DBObjectNotFoundException() throw() : DatabaseException("DB Object Not found error") {}
        DBObjectNotFoundException(__exString message) throw() : DatabaseException(message) {}
        virtual ~DBObjectNotFoundException() {} 

        DBObjectNotFoundException(const DBObjectNotFoundException &other) throw() : DatabaseException(other) {}
        DBObjectNotFoundException & operator= (const DBObjectNotFoundException &other) throw();
    };

  class InternalException: public SystemException
    {
      public:
        InternalException() throw() : SystemException("Internal error") {}
        InternalException(__exString message) throw() : SystemException(message) {}
        virtual ~InternalException() {} 

        InternalException(const DatabaseException &other) throw() : SystemException(other) {}
        InternalException & operator= (const InternalException &other) throw();
    };
}

#endif