//////////////////////////////////////////
// CustomerDatabase Implementation File //
//																	    //
//////////////////////////////////////////

#pragma warning (disable : 4786)

#ifndef  CUSTOMERDATABASE_CLASS 
#include "CustomerDatabase.h"
#endif

using namespace Customers;

CustomerDatabase & CustomerDatabase::GetInstance(void) throw()
{
  static CustomerDatabase as_Instance;
  return as_Instance;
}

// default ctor
CustomerDatabase::CustomerDatabase() throw()
: m_CustomerInformationCollection()  // ?????????
                                     // Initialize the map??
{
  LoadCustomerInformation();
}

// setup customerinformation
void CustomerDatabase::LoadCustomerInformation(void) throw()
{
  Customers::CustomerInformation a_Customer1("001","Chungho Chau","4043 S Ellesford Ave","West Covina","CA","91792",200);
  Customers::CustomerInformation a_Customer2("002","Carol Kwan",  "100 Garfield Ave",    "El Monte",   "CA","91720",500);
  
  WriteCustomerInformation(a_Customer1);
  WriteCustomerInformation(a_Customer2);
}


// dtor
CustomerDatabase::~CustomerDatabase() throw()
{
  // EMPTY
}

// Read Customer Information function
void CustomerDatabase::ReadCustomerInformation (Common::String Key, CustomerInformation & Buffer) const throw()
{
  std::map<Common::String, CustomerInformation>::iterator iMap;
  iMap = m_CustomerInformationCollection.find(Key);

  if ( iMap != m_CustomerInformationCollection.end() )
    { 
    Buffer = iMap->second; 
    }
}


// Write Customer Information function
void CustomerDatabase::WriteCustomerInformation (const CustomerInformation & Buffer) throw()
{
  Common::String Key = Buffer.GetCustomerCode();
  m_CustomerInformationCollection[Key] = Buffer;
}


// Delete Customer Information function
void CustomerDatabase::DeleteCustomerInformation (Common::String Key) throw()
{
  m_CustomerInformationCollection.erase(Key);
}