//////////////////////////////////////
// CustomerDatabase Header File  		//
//																	//
//////////////////////////////////////

#pragma once

#ifndef CUSTOMERDATABASE_CLASS  
#define CUSTOMERDATABASE_CLASS

#ifndef GENERIC_CLASS
#include "c:\scs\common\generic.h"
#endif

#ifndef STD__MAP
#include <map>
#define STD__MAP
#endif


#ifndef  CUSTOMERINFORMATION_CLASS 
#include "CustomerInformation.h"
#endif


namespace Common
{
  class InternalException;
  class DBObjectNotFoundException;
}

namespace Customers
{

  class CustomerDatabase
    {
    public:

        static CustomerDatabase & GetInstance(void) throw();
        
        ~CustomerDatabase() throw();

        void LoadCustomerInformation(void) throw();

        void ReadCustomerInformation (Common::String Key, /* CustomerCode */
                                      CustomerInformation & Buffer /* Object */)  const throw();

        void WriteCustomerInformation (const CustomerInformation & Buffer) throw();

        void DeleteCustomerInformation (Common::String Key) throw();        

         
    private:
      CustomerDatabase();  // singleton

      // Member Data
      //
      std::map<Common::String, CustomerInformation /*Object*/> m_CustomerInformationCollection;


      // Not implemented
      CustomerDatabase(const CustomerDatabase &other) throw();
      CustomerDatabase &operator= (const CustomerDatabase &other) throw();
      bool operator == (const CustomerDatabase &other) throw();  
    };
} 

#endif