/////////////////////////////////////////////
// CustomerInformation Implementation File //
//																	       //
/////////////////////////////////////////////

#pragma warning (disable : 4786)

#ifndef  CUSTOMERINFORMATION_CLASS 
#include "CustomerInformation.h"
#endif

using namespace Customers;

// default ctor
CustomerInformation::CustomerInformation() throw()
    :   m_CustomerCode("unknown"),
        m_Name("unknown"),
        m_Address ("unknown"),
        m_City("unknown"),
        m_State ("unknown"),
        m_ZipCode ("unknown"),
        m_CheckPaymentLimit(0.00)
{}


// ctor
CustomerInformation::CustomerInformation(Common::String Code, Common::String Name, Common::String Address,
                                         Common::String City, Common::String State, Common::String ZipCode,
                                         Common::Money CheckPaymentLimit) throw()
    :   m_CustomerCode(Code),
        m_Name(Name),
        m_Address (Address),
        m_City(City),
        m_State (State),
        m_ZipCode (ZipCode),
        m_CheckPaymentLimit(CheckPaymentLimit)
{}

// dtor
CustomerInformation::~CustomerInformation() throw()
{
  // Empty
}

CustomerInformation::CustomerInformation(const CustomerInformation &other) throw()
{
  m_CustomerCode      = other.m_CustomerCode;
  m_Name              = other.m_Name;
  m_Address           = other.m_Address;
  m_City              = other.m_City;
  m_State             = other.m_State;
  m_ZipCode           = other.m_ZipCode;
  m_CheckPaymentLimit = other.m_CheckPaymentLimit;
}

CustomerInformation &CustomerInformation::operator= (const CustomerInformation &other) throw()
{
  if (this == &other)
    return *this;

  m_CustomerCode      = other.m_CustomerCode;
  m_Name              = other.m_Name;
  m_Address           = other.m_Address;
  m_City              = other.m_City;
  m_State             = other.m_State;
  m_ZipCode           = other.m_ZipCode;
  m_CheckPaymentLimit = other.m_CheckPaymentLimit;

  return *this;
}

CustomerInformation & CustomerInformation::SetCustomerCode(Common::String Code) throw()
{
  m_CustomerCode = Code;
  return *this;
}

CustomerInformation & CustomerInformation::SetName(Common::String Name) throw()
{
  m_Name = Name;
  return *this;
}

CustomerInformation & CustomerInformation::SetAddress(Common::String Address) throw()
{
  m_Address = Address;
  return *this;
}

CustomerInformation & CustomerInformation::SetCity(Common::String City) throw()
{
  m_City = City;
  return *this;
}

CustomerInformation & CustomerInformation::SetState(Common::String State) throw()
{
  m_State = State;
  return *this;
}

CustomerInformation & CustomerInformation::SetZipCode(Common::String ZipCode) throw()
{
  m_ZipCode = ZipCode;
  return *this;
}

CustomerInformation & CustomerInformation::SetCheckPaymentLimit(Common::Money Limit) throw(Common::NegativeValueException)
{
  if (Limit < 0.0)
    {
    throw Common::NegativeValueException("Don't put in negative value!");
    }
  else
    {
    m_CheckPaymentLimit = Limit;
    }

  return *this;
}


