//////////////////////////////////////
// CustomerInformation Header File 	//
//																	//
//////////////////////////////////////

#pragma once

#ifndef CUSTOMERINFORMATION_CLASS  
#define CUSTOMERINFORMATION_CLASS

#ifndef GENERIC_CLASS
#include "c:\scs\common\generic.h"
#endif

#include "CustomerException.h"


namespace Common
{
  class NegativeValueException;
  class EmptyStringException;
}

namespace Customers
{

  class CustomerInformation
    {
    public:
        CustomerInformation();
        CustomerInformation(Common::String Code, Common::String Name, Common::String Address,
                            Common::String City, Common::String State, Common::String ZipCode,
                            Common::Money CheckPaymentLimit) throw();
        ~CustomerInformation() throw();

        CustomerInformation(const CustomerInformation &other) throw();

        CustomerInformation &operator= (const CustomerInformation &other) throw();

        // Access functions
        Common::String GetCustomerCode(void)       const throw() {return m_CustomerCode;} 
        Common::String GetName(void)               const throw() {return m_Name;}
        Common::String GetAddress(void)            const throw() {return m_Address;}
        Common::String GetCity(void)               const throw() {return m_City;}
        Common::String GetState(void)              const throw() {return m_State;}
        Common::String GetZipCode(void)            const throw() {return m_ZipCode;}
        Common::Money  GetCheckPaymentLimit(void)  const throw() {return m_CheckPaymentLimit;}

        CustomerInformation & SetCustomerCode(Common::String Code) throw();
        CustomerInformation & SetName(Common::String Name) throw();
        CustomerInformation & SetAddress(Common::String Address) throw();
        CustomerInformation & SetCity(Common::String City) throw();
        CustomerInformation & SetState(Common::String State) throw();
        CustomerInformation & SetZipCode(Common::String ZipCode) throw();
        CustomerInformation & SetCheckPaymentLimit(Common::Money Limit) throw(Common::NegativeValueException);
        
    private:
        // Member data
        //
        Common::String m_CustomerCode;
        Common::String m_Name;
        Common::String m_Address;
        Common::String m_City;
        Common::String m_State;
        Common::String m_ZipCode;
        Common::Money  m_CheckPaymentLimit;
    };

}
#endif