//////////////////////////////////////
// Main Test Driver File	  				//
//																	//
// Chungho Chau   Week 3          	//	
//																	//
//////////////////////////////////////
#pragma warning (disable : 4786)

#ifndef STD__IOSTREAM
#include <iostream>
#define STD__IOSTREAM
#endif

#include "Customers\CustomerDatabase.h"
#include "Customers\CustomerInformation.h"
#include "Supermarket\SupermarketDatabase.h"
#include "Supermarket\SupermarketInformation.h"
#include "Product\ProductDatabase.h"
#include "Product\ProductInformation.h"
#include "Transaction\CustomerTransaction.h"
#include "Transaction\PurchaseTransaction.h"
#include "Transaction\PaymentTransaction.h"
#include "Transaction\CashPaymentTransaction.h"
#include "Transaction\CheckPaymentTransaction.h"
#include "Station\CheckoutStation.h"
#include "Session\CheckoutSession.h"

#include "Common\Generic.h"
#include "Common\CommonException.h"
#include "Common\CommonEvent.h"

#include "Utility\ReferenceCounting.h"
#include "Utility\ReferenceCounting.h"
#include "Utility\Eventserver.h"
#include "Utility\Factory.h"

using std::cout;
using std::endl;

int main()
{
  // Initialize and register eventhandlers and eventbuilders
  Reactor & a_Reactor = Reactor::GetInstance();
  Station::CheckoutStation & a_Station = Station::CheckoutStation::GetInstance();
  EventMOG a_EventMOG;

  std::string a_rawEvent1 = "Open";
  std::string a_rawEvent2 = "Close";
  

  cout << "Dispatch an Open event via keyword OPEN ..." << endl;
  Event * a_EventPtr1 = Factory< std::string, EventBuilder, Event >::GetInstance().BuildProduct(a_rawEvent1);
  if ( a_EventPtr1 != 0 ) Reactor::GetInstance().DispatchEvent(*a_EventPtr1);

  cout << "Dispatch an Close event via keyword CLOSE ..." << endl;
  Event * a_EventPtr2 = Factory< std::string, EventBuilder, Event >::GetInstance().BuildProduct(a_rawEvent2);
  if ( a_EventPtr2 != 0 ) Reactor::GetInstance().DispatchEvent(*a_EventPtr2);

/*
  // Create Event Objects
  OpenSessionEvent   a_OpenSessionEvent;
  CancelSessionEvent a_CancelSessionEvent;

  // Initial state is NoSessionState
  cout << "Current state is NoSessionState" << endl;

  // Send Event signal
  cout << "Dispatch an CancelSessionEvent ..." << endl;
  a_Reactor.DispatchEvent(a_CancelSessionEvent);

  cout << "Dispatch an OpenSessionEvent ..." << endl;
  a_Reactor.DispatchEvent(a_OpenSessionEvent);

  cout << "Dispatch an OpenSessionEvent ..." << endl;
  a_Reactor.DispatchEvent(a_OpenSessionEvent);

  cout << "Dispatch an CancelSessionEvent ..." << endl;
  a_Reactor.DispatchEvent(a_CancelSessionEvent);

  cout << "Dispatch an OpenSessionEvent ..." << endl;
  a_Reactor.DispatchEvent(a_OpenSessionEvent);

*/
  
  
    
  

  // Sessions::CheckoutSession & a_Session = a_Station.GetCheckoutSession();

/*
  Transactions::CustomerTransaction * a_Transaction1 = new Transactions::PurchaseTransaction();
  a_Session.AddCustomerTransactionPointer(a_Transaction1);

  Transactions::CustomerTransaction * a_Transaction2 = new Transactions::CheckPaymentTransaction();
  a_Session.AddCustomerTransactionPointer(a_Transaction2);

  Transactions::CustomerTransaction * a_Transaction3 = new Transactions::CashPaymentTransaction();
  a_Session.AddCustomerTransactionPointer(a_Transaction3);
*/
  /*
  // checkoutSession "destructor" will take care of all deletion of Transaction pointers
  a_Session.RemoveCustomerTransactionPointer(a_Transaction1);
  a_Session.RemoveCustomerTransactionPointer(a_Transaction2);
  a_Session.RemoveCustomerTransactionPointer(a_Transaction3);
  */

  // using RCPointer type:: need some code modifications ...
  // RCPointer<Transactions::CustomerTransaction> a_RCTransaction;
  // a_Session.AddCustomerTransactionPointer(a_RCTransaction);
  

  

/*  
  // ** test for SupermarketDatabase
  // initialize data:
  Supermarket::SupermarketDatabase::GetInstance();
  Products::ProductDatabase::GetInstance();
  Customers::CustomerDatabase::GetInstance();

  Customers::CustomerDatabase & a_CustomerDatabase = Customers::CustomerDatabase::GetInstance();

  Customers::CustomerInformation a_Customer;
  a_CustomerDatabase.ReadCustomerInformation("001", a_Customer);  // if not found, use default customerinformation

  cout << "Name:\t\t"     << a_Customer.GetName()              << endl;
  cout << "Address:\t"    << a_Customer.GetAddress()           << endl;
  cout << "City:\t\t"     << a_Customer.GetCity()              << endl;
  cout << "State:\t\t"    << a_Customer.GetState()             << endl;
  cout << "ZipCode:\t"    << a_Customer.GetZipCode()           << endl;
  cout << "CheckLimit:\t" << a_Customer.GetCheckPaymentLimit() << endl;
  cout << endl;




  // Create a Concrete Event Object
  // OpenCheckoutSession a_OCSEvent;

  // Send Event signal to Reactor::Dispatch(), 
  // then to "virutal" EventHandler::HandleEvent() 
  // Reactor::GetInstance().DispatchEvent(a_OCSEvent); 
*/


  // RCPointer<Transactions::CustomerTransaction> CustomerTransactionPtr1, CustomerTransactionPtr2;
  // a_Session.AddCustomerTransactionPointer(CustomerTransactionPtr1);
  

  cout << endl;
	return 0;
}
