////////////////////////////////////////
// PurchaseDatabase Implementation	  //
//																	  //
////////////////////////////////////////

#pragma warning (disable : 4786)

#ifndef  PRODUCTDATABASE_CLASS
#include "ProductDatabase.h"
#endif

using namespace Products;

ProductDatabase & ProductDatabase::GetInstance(void)
{
  static ProductDatabase as_Instance;
  return as_Instance;
}

// default ctor
ProductDatabase::ProductDatabase() throw()
{
  // empty
}


// dtor
ProductDatabase::~ProductDatabase() throw()
{
  // empty
}

// Read Production Information function
void ProductDatabase::ReadProductInformation(Common::UPCCode Key,
                                             ProductInformation & other) const throw()
{
  std::map<Common::UPCCode, ProductInformation >::iterator MapIter;
  MapIter = m_ProductInformationMap.find(Key);

  if ( MapIter != m_ProductInformationMap.end() )
    other = MapIter->second; // second is the object data
}

// Write function
void ProductDatabase::WriteProductInformation(const ProductInformation &other) throw()
{
  Common::UPCCode Key = other.GetProductCode();
  m_ProductInformationMap[Key] = other;
}

// Delete with Key supplied
void ProductDatabase::DeleteProductInformation(Common::UPCCode Key) throw()
{
  m_ProductInformationMap.erase(Key);
}

// Delete with Object supplied
void ProductDatabase::DeleteProductInformation(const ProductInformation &other) throw()
{
  Common::UPCCode Key = other.GetProductCode();
  DeleteProductInformation(Key);
}




