////////////////////////////////////////
// ProductDatabase Implementation	  //
//																	  //
////////////////////////////////////////

#pragma once

#ifndef PRODUCTDATABASE_CLASS
#define PRODUCTDATABASE_CLASS

#ifndef  PRODUCTINFORMATION_CLASS
#include "c:\scs\product\ProductInformation.h"
#endif

#ifndef  GENERIC_CLASS
#include "c:\scs\common\generic.h"
#endif

#ifndef STD__MAP
#include <map>
#define STD__MAP
#endif


namespace Common
{
  class InternalException;
  class DBObjectNotFoundException;
}

namespace Products
{

  class ProductDatabase
    {
      public:
        static ProductDatabase & GetInstance(void);

        ~ProductDatabase() throw();

        void ReadProductInformation(Common::UPCCode Key,
                                    ProductInformation & other) const throw();

        void WriteProductInformation(const ProductInformation &other) throw();
        
        void DeleteProductInformation(Common::UPCCode Key) throw();
        void DeleteProductInformation(const ProductInformation &other) throw();

      private:
        ProductDatabase() throw();

        // Create Product Container using Map member data
        //
        // typedef std::map< Common::UPCCode, ProductInformation *> ProductInformationMap; 
        // ProductInformationMap m_ProductInformation;
     // ********************************************************************
        std::map<Common::UPCCode, ProductInformation > m_ProductInformationMap;
     // ********************************************************************

        // Implement later ...
        ProductDatabase(const ProductDatabase &other) throw();
        ProductDatabase &operator= (const ProductDatabase &other) throw();
        bool operator == (const ProductDatabase &other) throw();  
    };
}

#endif