////////////////////////////////////////
// CheckoutSession Implementation	    //
//																	  //
////////////////////////////////////////

#ifndef  CHECKOUTSESSION_CLASS
#include "CheckoutSession.h"
#endif

#include <algorithm>

using namespace Sessions;
using namespace Station;


// ctor
CheckoutSession::CheckoutSession(Station::CheckoutStation & other) throw()
//: m_CustomerTransactionPtrVector(0)
: m_CheckoutStation(other), // Declare which Station is each Session in
// if use member as "object" of ChcecoutStation, then CheckoutStation::CheckoutStation' : cannot access private member ??
  m_NumberTransaction(0), EventHandler() 
{
  // Need to overload operator= in Station class ???
  // m_CheckoutStation.GetCheckoutSessionPointer = this;

  //Reactor::GetInstance().RegisterHandler( typeid(CloseCheckoutSession), *this); 
}


// Destructor
CheckoutSession::~CheckoutSession() throw(Common::InternalException)
{
  // delete current transactions

  try 
  {
    //std::vector< RCPointer<Transactions::CustomerTransaction> >::iterator vectorIter;
    std::vector< Transactions::CustomerTransaction * >::iterator vectorIter;
    for (vectorIter = m_CustomerTransactionPtrCollection.begin(); ( vectorIter != m_CustomerTransactionPtrCollection.end() ); ++vectorIter )
    {
      if ( *vectorIter != 0 )
      {
        // ** Delete Transaction nd Derived class Pointer(s) 
        cout << "Deleting pointer of " << std::string( typeid(**vectorIter).name() ) << endl;
        // delete the pointers it <vector> contains
        // Need to have "virtual" destructor for all Transaction derived class
        // otherwise, Exception on exiting main() ... cool
        delete *vectorIter; 
        
      }
    }
  }
  catch (std::exception & ex)
  {
    throw Common::InternalException(ex.what());
  }
}


// Get function
Station::CheckoutStation & CheckoutSession::GetCheckoutStation(void) const throw()
{
  return m_CheckoutStation;
}

// Add function
CheckoutSession & CheckoutSession::AddCustomerTransactionPointer ( Transactions::CustomerTransaction * p_NewTransactionPtr) throw(Common::InternalException)
{
  try
  {
    if (p_NewTransactionPtr)
    {
      m_CustomerTransactionPtrCollection.push_back(p_NewTransactionPtr);
      m_NumberTransaction++;
      return *this;
    }
    return *this;
  }
  catch (std::exception & ex)
  {
    throw Common::InternalException(ex.what());
  }  
}

// Remove function
void CheckoutSession::RemoveCustomerTransactionPointer ( Transactions::CustomerTransaction * p_TransactionPtr) throw(Common::InternalException)
{
  try
  {
    std::vector< Transactions::CustomerTransaction * >::iterator i;
    // utilize "find" function in <algorithm> to locate "iterator" location
    i = std::find( m_CustomerTransactionPtrCollection.begin(), m_CustomerTransactionPtrCollection.end(), p_TransactionPtr);

    if ( i != m_CustomerTransactionPtrCollection.end() )
    {
      if ( *i != 0 ) // CustomerTransaction *
      {
        delete *i;   // Cool ...
      }
      // Remove record in the vector 
      m_CustomerTransactionPtrCollection.erase(i);
    }
  }
  catch ( std::exception & p_exception)
  {
    throw Common::InternalException ( p_exception.what() );
  }
}


// Delete "Last" pointer function
void CheckoutSession::DeleteLastCustomerTransactionPointer (void) throw(Common::InternalException)
{
  try
  {
    m_CustomerTransactionPtrCollection.erase(m_CustomerTransactionPtrCollection.end()-1);
    m_NumberTransaction--;
  }
  catch (std::exception & ex)
  {
    throw Common::InternalException(ex.what());
  }  
}


// Get function
int CheckoutSession::GetNumberTransaction(void) const throw()
{
  return m_NumberTransaction;
}


// Handle all Session related Event
void CheckoutSession::HandleEvent (const Event & p_Event)
{
//  if ( typeid(p_Event) == typeid(CloseCheckoutSession) )
//    cout << "CheckoutSession::HandleEvent() -- CloseCheckoutSession Action was performed." << endl;
//  cout << "Hello from CheckoutSession::HandleEvent()." << endl;
}

/*
// Add pointer function with Reference Counter
CheckoutSession & CheckoutSession::AddCustomerTransactionPointer ( RCPointer<Transactions::CustomerTransaction> otherPtr) throw(Common::InternalException)
{
  try
  {
    if (otherPtr)
    {
      m_CustomerTransactionPtrCollection.push_back(otherPtr);
      m_NumberTransaction++;
      return *this;
    }
    return *this;
  }
  catch (std::exception & ex)
  {
    throw Common::InternalException(ex.what());
  }  
}
*/