////////////////////////////////////////
// CheckoutSession Implementation	    //
//																	  //
////////////////////////////////////////

#pragma once

#ifndef CHECKOUTSESSION_CLASS
#define CHECKOUTSESSION_CLASS

#include "c:\scs\utility\ReferenceCounting.h"

#ifndef STD__VECTOR
#include <vector>
#define STD__VECTOR
#endif

namespace Station
  {
  class CheckoutStation;
  }

namespace Common 
{ 
  class InternalException;
} 

using namespace Station;

#include "C:\SCS\Station\CheckoutStation.h"

#ifndef  CUSTOMERTRANSACTION_CLASS
#include "c:\scs\Transaction\CustomerTransaction.h"
#endif

#ifndef  EVENTSERVER_CLASS
#include "C:\scs\utility\EventServer.h"
#endif

namespace Sessions
  {

  class CheckoutSession: public EventHandler
    {
    public:
        CheckoutSession(Station::CheckoutStation & p_Station) throw();
        virtual ~CheckoutSession() throw(Common::InternalException);
        
        Station::CheckoutStation & GetCheckoutStation(void) const throw();

        CheckoutSession & AddCustomerTransactionPointer ( RCPointer<Transactions::CustomerTransaction> otherPtr) throw(Common::InternalException);
        void              DeleteLastCustomerTransactionPointer (void) throw(Common::InternalException);

        CheckoutSession & AddCustomerTransactionPointer    ( Transactions::CustomerTransaction * p_NewTransactionPtr) throw(Common::InternalException);
        void              RemoveCustomerTransactionPointer ( Transactions::CustomerTransaction * p_TransactionPtr)    throw(Common::InternalException);


        int GetNumberTransaction(void) const throw();

        // ** Handle Event virtual function **
        virtual void HandleEvent (const Event & p_Event);

    private:
        // Memeber Data
        //
        // back reference which station class session belongs to
        Station::CheckoutStation & m_CheckoutStation;
        int m_NumberTransaction;

        // ** Create a Container to hold Transaction Pointer records **
        // ************************************************************
        // create a vector to store Transaction records ** OLD **
        // std::vector< Transactions::CustomerTransaction *> m_CustomerTransactionPtrVector;

        // create a vector to hold a reference counting pointer class to CustomerTransaction class
        // std::vector< RCPointer<Transactions::CustomerTransaction> > m_CustomerTransactionPtrCollection;

        std::vector< Transactions::CustomerTransaction * > m_CustomerTransactionPtrCollection;

        // Can't be applied
        CheckoutSession(const CheckoutSession &other) throw();
        CheckoutSession &operator= (const CheckoutSession &other) throw();
    };
  }


#endif