////////////////////////////////////////
// CheckoutStation Header   .hpp 	    //
//																	  //
////////////////////////////////////////

//  7/22/98  Make Station Singleton

#pragma once

#ifndef CHECKOUTSTATION_CLASS
#define CHECKOUTSTATION_CLASS

#ifndef GENERIC_CLASS
#include "c:\scs\common\generic.h"
#endif

#ifndef  CHECKOUTSESSION_CLASS
#include "C:\scs\Session\CheckoutSession.h"
#endif

#include "StationException.h"

namespace Sessions
{
  class CheckoutSession;
}

namespace Station
{ 
  class NoAttachedSessionException;  
}

namespace Common
{
  class InternalException;
  class InvalidPointerException;
}

// why can't I put it inside the namespace???
class CheckoutStationState;

namespace Station
{
  class CheckoutStation
  {
    public:
      static CheckoutStation & GetInstance(void);
      
      virtual ~CheckoutStation()
        throw();

      // virtual void HandleEvent (const Event & p_Event);

      // allocate new session and Remove session
      void AttachNewCheckoutSession() throw(Common::InternalException);
      void DetachCurrentCheckoutSession() throw();

      // Get Session Information
      Sessions::CheckoutSession & GetCheckoutSession(void) const throw(NoAttachedSessionException);
            
      // Get Station Information
      Common::String GetStationName(void) const throw();

      // StateMachine 7/29/98 : Change state base on event
      void SetState(CheckoutStationState * p_NewStatePtr);  

    private:
      // StateMachine 7/29/98
      CheckoutStationState * m_CheckoutStationStatePtr;

      // Singleton 7/24/98
      CheckoutStation() throw();
      CheckoutStation(Common::String Name) throw();

      // will not be implemented
      CheckoutStation(const CheckoutStation &other) throw();
      CheckoutStation &operator= (const CheckoutStation &other) throw();
     

      // Data Member
      //
      // ** Station Class contains a Session Pointer **
      // **********************************************
      // use pointer so that NULL pointer can be used
      Sessions::CheckoutSession * m_CheckoutSessionPtr;  // points to what??
      // *pointer* need to be deleted in destructor
      // Question:
      //    what is the pointer relationship between different session within same station
      
      Common::String m_Name;
  };
}

#endif