//////////////////////////////////////
//                    							//
//	StationException Header			    //
//		                            	//	
//																	//
//////////////////////////////////////

#pragma once

#ifndef STATIONEXCEPTION_CLASS  
#define STATIONEXCEPTION_CLASS

#include "c:\scs\common\CommonException.h"

namespace Station
{

  class StationException: public Common::SystemException
    {
    public:
      StationException() throw() : SystemException("CheckoutStation Exception") {}
      StationException(__exString message) throw() : SystemException(message) {}
      StationException (const StationException &other) throw() : SystemException(other) {}
      virtual ~StationException() throw() {}
      StationException & operator= (const StationException &other) throw() 
          {SystemException::operator= (other); return *this;}    
        
    };


  class NoAttachedSessionException: public StationException
    {
    public:
      NoAttachedSessionException() throw() : StationException("CheckoutStation Exception") {}
      NoAttachedSessionException(__exString message) throw() : StationException(message) {}
      NoAttachedSessionException (const NoAttachedSessionException &other) throw() : StationException(other) {}
      virtual ~NoAttachedSessionException() throw() {}
      NoAttachedSessionException & operator= (const NoAttachedSessionException &other) throw() 
          {StationException::operator= (other); return *this;}    
        
    };

  


}  // namespace of Station





#endif