//////////////////////////////////////
// SuperMarketDatabase Header File  //
//																	//
//////////////////////////////////////

#pragma once

#ifndef SUPERMARKETDATABASE_CLASS  
#define SUPERMARKETDATABASE_CLASS

#ifndef  SUPERMARKETINFORMATION_CLASS 
#include "SupermarketInformation.h"
#endif

namespace Supermarket
  {  
  class SupermarketDatabase
    {
    public:
        static SupermarketDatabase & GetInstance(void);

        ~SupermarketDatabase() throw() {}

        // Member Functions:
        //
        SupermarketInformation ReadSupermarketInformation( const SupermarketInformation &other) const throw();
        SupermarketInformation & WriteSupermarketInformation( const SupermarketInformation &other) throw();
        
    private:
        SupermarketDatabase()  throw();

        // Contains object of SupermarketInformation: one to one aggregation
        // When SupermarketDatabase is destroyed, so as SupermarketInformation 
        // Data member in private and hence supermarketInformation is disallowed
        //   to be deleted while supermarket still exists.
        //
        SupermarketInformation m_supermarketInformation;
        
        SupermarketDatabase(const SupermarketDatabase &other) throw();
        SupermarketDatabase & operator=(const SupermarketDatabase &other) throw();
        
    };
  }

#endif