////////////////////////////////////////
// PaymentTransaction Implementation	//
//																	  //
////////////////////////////////////////

#ifndef  PAYMENTTRANSACTION_CLASS
#include "PaymentTransaction.h"
#endif

using namespace Transactions;


// Default ctor
PaymentTransaction::PaymentTransaction() throw()
  :   CustomerTransaction(),
      m_Amount(0.00)
  {
  }


// Destructor
PaymentTransaction::~PaymentTransaction() throw()
  {
  }


// Copy ctor
PaymentTransaction::PaymentTransaction(const PaymentTransaction &other) throw()
  :   CustomerTransaction(other),
      m_Amount(other.m_Amount)
  {
  }

PaymentTransaction &PaymentTransaction::operator= (const PaymentTransaction &other) throw()
{
  if (this == &other)
    return *this;

  m_Amount = other.m_Amount;
  CustomerTransaction::operator= (other);

  return *this;
}


// Set function
PaymentTransaction &PaymentTransaction::SetAmount(Common::Money Amount) throw(Common::OutOfRangeException)
{
  if (Amount < 0.0)
    throw Common::OutOfRangeException();
  else
    m_Amount = Amount;
  
  return *this;
}