////////////////////////////////////////
// PaymentTransaction Implementation	//
//																	  //
////////////////////////////////////////

#pragma once

#ifndef PAYMENTTRANSACTION_CLASS
#define PAYMENTTRANSACTION_CLASS

#ifndef GENERIC_CLASS
#include "c:\scs\common\generic.h"
#endif

#ifndef  CUSTOMERTRANSACTION_CLASS
#include "CustomerTransaction.h"
#endif

namespace Common
{
  class OutOfRangeException;
  class NegativeValueException;
}

#include "TransactionException.h"

namespace Transactions
  {

  class PaymentTransaction: public CustomerTransaction
    {
    public:
        PaymentTransaction() throw();
        virtual ~PaymentTransaction() throw() = 0;

        PaymentTransaction(const PaymentTransaction &other) throw();
        PaymentTransaction &operator= (const PaymentTransaction &other) throw();

    private:
        // Data member
        Common::Money m_Amount;

        // Data access functions
        Common::Money GetAmount(void) const throw() {return m_Amount;}
        PaymentTransaction &SetAmount(Common::Money Amount) throw(Common::OutOfRangeException);
    };
  }

#endif